//+------------------------------------------------------------------+
//|                                                             usdx |
//|                                                         usdx.mq4 |
//| developed at www.forex-tsd.com                                   |
//+------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 Red

//
//
//
//
//

double buffer[];
string symbols[] = {"EURUSD","USDJPY","GBPUSD","USDCAD","USDSEK","USDCHF"};  
double weights[] = {-0.576,-0.136,-0.119,-0.091,-0.042,-0.036};
bool   divide[]  = {false,true,false,true,true,true};
string addition;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,buffer);
   IndicatorShortName("USDX ");
   if (StringFind(Symbol(),"m") > -1)
      for (int i =0; i <6; i++)
         symbols[i] = symbols[i]+"m";

   return(0);
}
int deinit()
{
   return(0);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;
   
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=Bars-counted_bars;

   //
   //
   //
   //
   //
   
   
   for(i=limit; i>=0; i--)
   {
      double product = 0.00;
      bool   error   = false;
         
      //
      //
      //
      //
      //
       
      buffer[i] = EMPTY_VALUE;     
           for (int k=0; k<6; k++)
            {
               double rateWeight = rateWeight(i,k,error);
                  if ( error ) break;
                  if ( product == 0.00)
                       product  = rateWeight;
                  else product *= rateWeight;                   
            }               
            if ( error ) continue;
      buffer[i] = product*50.14348112;
   }            
   return(0);
}
  
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//

double rateWeight(int i, int k, bool& error)
{
   double price  = iClose(symbols[k],0,i);
   double weight = 0.00;
   
   if (price == 0) { error = true; return(0); }
   if (divide[k])
        weight = 1/price;
   else weight =   price;
   return(MathPow(weight,weights[k]));
}